Package org.codehaus.groovy.transform

# Class EqualsAndHashCodeASTTransformation

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.EqualsAndHashCodeASTTransformation

All Implemented Interfaces:
  `ASTTransformation`, `ErrorCollecting`

public class EqualsAndHashCodeASTTransformation extends AbstractASTTransformation
Handles generation of equals() and hashCode() methods via the `EqualsAndHashCode` annotation.

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `EqualsAndHashCodeASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes)`
  Generates an equals method for the given class.
  `static void`
  `createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames)`
  Generates an equals method for the given class.
  `static void`
  `createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties)`
  Generates an equals method for the given class.
  `static void`
  `createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo)`
  Generates an equals method for the given class.
  `static void`
  `createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo, boolean useGetter)`
  Generates an equals method for the given class.
  `static void`
  `createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes)`
  Generates a hashCode method for the given class.
  `static void`
  `createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames)`
  Generates a hashCode method for the given class.
  `static void`
  `createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties)`
  Generates a hashCode method for the given class.
  `static void`
  `createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo)`
  Generates a hashCode method for the given class.
  `static void`
  `createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo, boolean useGetter)`
  Generates a hashCode method for the given class.
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getAnnotationName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### EqualsAndHashCodeASTTransformation

    public EqualsAndHashCodeASTTransformation()

- ## Method Details

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

  - ### createHashCode

    public static void createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes)
    Generates a hashCode method for the given class.
    Parameters:
      `cNode` - the class to add hashCode method to
      `cacheResult` - whether to cache the hash code in a field
      `includeFields` - whether to include fields in the hash code
      `callSuper` - whether to include superclass hash code
      `excludes` - property names to exclude
      `includes` - property names to include

  - ### createHashCode

    public static void createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames)
    Generates a hashCode method for the given class.
    Parameters:
      `cNode` - the class to add hashCode method to
      `cacheResult` - whether to cache the hash code in a field
      `includeFields` - whether to include fields in the hash code
      `callSuper` - whether to include superclass hash code
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')

  - ### createHashCode

    public static void createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties)
    Generates a hashCode method for the given class.
    Parameters:
      `cNode` - the class to add hashCode method to
      `cacheResult` - whether to cache the hash code in a field
      `includeFields` - whether to include fields in the hash code
      `callSuper` - whether to include superclass hash code
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')
      `allProperties` - whether to process all properties

  - ### createHashCode

    public static void createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo)
    Generates a hashCode method for the given class.
    Parameters:
      `cNode` - the class to add hashCode method to
      `cacheResult` - whether to cache the hash code in a field
      `includeFields` - whether to include fields in the hash code
      `callSuper` - whether to include superclass hash code
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')
      `allProperties` - whether to process all properties
      `pojo` - whether to treat as plain old Java object

  - ### createHashCode

    public static void createHashCode(ClassNode cNode, boolean cacheResult, boolean includeFields, boolean callSuper, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo, boolean useGetter)
    Generates a hashCode method for the given class.
    Parameters:
      `cNode` - the class to add hashCode method to
      `cacheResult` - whether to cache the hash code in a field
      `includeFields` - whether to include fields in the hash code
      `callSuper` - whether to include superclass hash code
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')
      `allProperties` - whether to process all properties
      `pojo` - whether to treat as plain old Java object
      `useGetter` - whether to use getter methods instead of direct field access

  - ### createEquals

    public static void createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes)
    Generates an equals method for the given class.
    Parameters:
      `cNode` - the class to add equals method to
      `includeFields` - whether to include fields in the comparison
      `callSuper` - whether to include superclass comparison
      `useCanEqual` - whether to generate and use a canEqual helper method
      `excludes` - property names to exclude
      `includes` - property names to include

  - ### createEquals

    public static void createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames)
    Generates an equals method for the given class.
    Parameters:
      `cNode` - the class to add equals method to
      `includeFields` - whether to include fields in the comparison
      `callSuper` - whether to include superclass comparison
      `useCanEqual` - whether to generate and use a canEqual helper method
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')

  - ### createEquals

    public static void createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties)
    Generates an equals method for the given class.
    Parameters:
      `cNode` - the class to add equals method to
      `includeFields` - whether to include fields in the comparison
      `callSuper` - whether to include superclass comparison
      `useCanEqual` - whether to generate and use a canEqual helper method
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')
      `allProperties` - whether to process all properties

  - ### createEquals

    public static void createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo)
    Generates an equals method for the given class.
    Parameters:
      `cNode` - the class to add equals method to
      `includeFields` - whether to include fields in the comparison
      `callSuper` - whether to include superclass comparison
      `useCanEqual` - whether to generate and use a canEqual helper method
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')
      `allProperties` - whether to process all properties
      `pojo` - whether to treat as plain old Java object

  - ### createEquals

    public static void createEquals(ClassNode cNode, boolean includeFields, boolean callSuper, boolean useCanEqual, List<String> excludes, List<String> includes, boolean allNames, boolean allProperties, boolean pojo, boolean useGetter)
    Generates an equals method for the given class.
    Parameters:
      `cNode` - the class to add equals method to
      `includeFields` - whether to include fields in the comparison
      `callSuper` - whether to include superclass comparison
      `useCanEqual` - whether to generate and use a canEqual helper method
      `excludes` - property names to exclude
      `includes` - property names to include
      `allNames` - whether to include all names (including internal ones with '$')
      `allProperties` - whether to process all properties
      `pojo` - whether to treat as plain old Java object
      `useGetter` - whether to use getter methods instead of direct field access